
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

const nsISupports = Components.interfaces.nsISupports;
//const nsIYarip = Components.interfaces.nsIYarip;
const CLASS_ID = Components.ID("{46d09504-6a0b-40c8-8ce8-d07cf370d25e}");
const CLASS_NAME = "Yet Another Remove It Permanently";
const CONTRACT_ID = "@yarip.mozdev.org;1";

const prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

var yarip = {
	STYLE: "extensions/yarip@mozdev.org/style.css",
	XPATH: "yarip.xml",

	PAGE_MODE: 0,
	FQDN_MODE: 1,
	SLD_MODE: 2,
	USER_MODE: 3,

	TYPE_WHITELIST: 0,
	TYPE_BLACKLIST: 1,
	TYPE_STYLE: 2,

	NO_CHANGE: 0,
	MINOR_CHANGE: 1,
	ESSENTIAL_CHANGE: 2,

	BOOLEAN: 0,
	INTEGER: 1,
	STRING: 2,
	RESET: 3,

	FIRSTRUN: "extensions.yarip.firstrun",
	VERSION: "extensions.yarip.version",
	ENABLED_ROOT: "extensions.yarip.enabled.",
	ENABLED: "extensions.yarip.enabled.value",
	FLICKER_ROOT: "extensions.yarip.noFlicker.",
	FLICKER: "extensions.yarip.noFlicker.value",
	MODE_ROOT: "extensions.yarip.mode.",
	MODE: "extensions.yarip.mode.value",
	DEEP_ROOT: "extensions.yarip.deep.",
	DEEP: "extensions.yarip.deep.value",
	RELOAD_ROOT: "extensions.yarip.reload.",
	RELOAD: "extensions.yarip.reload.value",
	INDEX_ROOT: "extensions.yarip.alwaysUseIndex.",
	INDEX: "extensions.yarip.alwaysUseIndex.value",
	VALUE: "value",

	CHARSET: "UTF-8",

	enabled: null,
	noFlicker: null,
	mode: null,
	deep: null,

	alwaysUseIndex: false,
	changeType: 0,

	address: null,
	aAddress: null,
	map: null,
	undoObj: {}
}

yarip.OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
yarip.UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
yarip.SCHEME = "(" + yarip.OFFICIAL_SCHEME + "|" + yarip.UNOFFICIAL_SCHEME + "):";
yarip.IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
yarip.IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
yarip.IP = "(" + yarip.IPV4ADDRESS + "|" + yarip.IP_LITERAL + ")";
yarip.AUTHORITY = "([a-z\\d]([\\w-.~!$&*+,=:]|%[a-f\\d]{2})*@)?";
yarip.REG_NAME = "([a-z\\d]([\\w-~!$&*+,=@]|%[a-f\\d]{2})+\\.)+";
yarip.HOSTNAME = "[a-z\\d]([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.SLD = "[a-z\\d]([\\w-~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
yarip.HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + yarip.IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)(:\\d+)?))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
yarip.PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
yarip.QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";

yarip.URI1 = "(" + yarip.SCHEME + yarip.HIER_PART + yarip.QUERY_FRAGMENT + ")";
yarip.URI2 = "(" + yarip.AUTHORITY + "(" + yarip.IP + "|(" + yarip.REG_NAME + yarip.TLD + "\\b))(:\\d+)?" + yarip.PATH + yarip.QUERY_FRAGMENT + ")";

yarip.uriRegExp = new RegExp("^(" + yarip.URI1 + "|" + yarip.URI2 + ")$", "i");
yarip.noSchemeRegExp = new RegExp("^" + yarip.URI2 + "$", "i");
yarip.domainRegExp = new RegExp("^(" + yarip.IP + "|(" + yarip.HOSTNAME + yarip.TLD + "))$", "i");
yarip.findDomainRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.HOSTNAME + yarip.TLD + "))\\b", "i");
yarip.findSldRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.SLD + yarip.TLD + "))$", "i");

yarip.outlineRegExp = /^outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;
yarip.endOutlineRegExp = /outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;

yarip.toggleEnabled = function(enabled)
{
	if (enabled == this.enabled) return false;

	if (enabled != true && enabled != false) enabled = !this.enabled;
	this.enabled = enabled;
	this.save();

	if (enabled) this.toggleNoFlicker(this.getValue(this.FLICKER, false, this.BOOLEAN), null, true);
	else this.toggleNoFlicker(false, true, true);

	this.setValue(this.ENABLED, enabled, this.BOOLEAN); // notify
	return true;
}

yarip.toggleNoFlicker = function(noFlicker, dontNotify, force)
{
	if (noFlicker == this.noFlicker && !force) return false;

	if (noFlicker != true && noFlicker != false) noFlicker = !this.noFlicker;
	this.noFlicker = noFlicker;

	if (this.noFlicker && this.enabled)
	{
		this.setValue("content.notify.ontimer", true, this.BOOLEAN);
		this.setValue("content.notify.backoffcount", 0, this.RESET);
		this.setValue("nglayout.initialpaint.delay", 5000, this.INTEGER);
	}
	else
	{
		this.setValue("content.notify.ontimer", null, this.RESET);
		this.setValue("content.notify.backoffcount", null, this.RESET);
		this.setValue("nglayout.initialpaint.delay", null, this.RESET);
	}

	this.toggleStyle();
	this.injectCSS("chrome://yarip/content/noflicker.css", this.noFlicker && this.enabled);
	if (!dontNotify) this.setValue(this.FLICKER, this.noFlicker, this.BOOLEAN); // notify
	return true;
}

yarip.toggleStyle = function()
{
	var file = this.getFile(this.STYLE);
	if (file) this.injectCSS("file://" + file.path, this.noFlicker && this.enabled);
}

yarip.setMode = function(mode)
{
	if (mode != this.USER_MODE && (mode == this.mode || typeof mode != "number")) return false;
	this.mode = mode;
	this.setValue(this.MODE, mode, this.INTEGER); // notify
	return true;
}

yarip.toggleDeep = function(deep)
{
	if (deep == this.deep) return false;

	if (deep != true && deep != false) deep = !this.deep;
	this.deep = deep;

	this.setValue(this.DEEP, deep, this.BOOLEAN); // notify
	return true;
}

yarip.setAlwaysUseIndex = function(alwaysUseIndex)
{
	if (alwaysUseIndex == true || alwaysUseIndex == false) this.alwaysUseIndex = alwaysUseIndex;
}

yarip.setChangeType = function(type, force)
{
	if (!this.changeType || type > this.changeType || force) this.changeType = type;
}

yarip.getAddress = function(doc, mode)
{
	if (typeof mode != "number") mode = this.mode;
	if (!doc || !doc.location) return null;

	var address = null;
	try
	{
		switch(mode)
		{
			case this.PAGE_MODE:
				this.address = null;
				address = doc.location.protocol + "//" + doc.location.host + doc.location.pathname;
				break;

			case this.FQDN_MODE:
				this.address = null;
				address = doc.location.hostname;
				break;

			case this.SLD_MODE:
				this.address = null;
				var sld = doc.location.hostname.match(this.findSldRegExp);
				if (sld) address = sld[0];
				break;

			case this.USER_MODE:
				if (this.address
				 && this.address.match(this.uriRegExp)
				 && doc.location.hostname.match(new RegExp("(^|\\.)" + this.address.match(this.findDomainRegExp)[0].replace(/(\W)/g, "\\$1") + "$"))
				 && (doc.location.protocol + "//" + doc.location.host + doc.location.pathname).match(new RegExp(this.address.replace(/(\W)/g, "\\$1")))
				) address = this.address;
		}
		if (address == "") return null;
	}
	catch(e){}
	return address;
}

yarip.getAddressArray = function(doc)
{
	if (!doc) return null;

	this.aAddress = {}
	var tmpDomain = null;
	var reduceDomain = this.getAddress(doc, this.PAGE_MODE);

	while (reduceDomain != tmpDomain)
	{
		var tmpPath = null;
		var reducePath = reduceDomain;

		while (reducePath != tmpPath)
		{
			var page = this.map.obj[reducePath];
			if (page)
			{
				this.aAddress[reducePath] = true;
//				if (page.extension.length > 0) this.getRecursiveAddressArray(reducePath);
			}
			tmpPath = reducePath;
			reducePath = reducePath.replace(/(\/|[^/]*)$/, "");
		}

		tmpDomain = reduceDomain;
		reduceDomain = reduceDomain.replace(/^([^:]+:\/\/|[^.]+\.)/, "");
	}

	return this.aAddress;
}

yarip.getExtensionAddressArray = function(aAddress)
{
	if (!aAddress) return null;

	this.aAddress = {}
	for (a in aAddress) this.getRecursiveAddressArray(a);
	return this.aAddress;
}

yarip.getRecursiveAddressArray = function(address)
{
	for (var id in this.map.obj[address].extension.xpaths)
	{
		var page = this.map.objId[id];
		if (page)
		{
			var pName = page.getName();
			if (this.aAddress[pName]) continue;

			this.aAddress[pName] = true;

			if (page.extension.length > 0) this.getRecursiveAddressArray(pName);
		}
		else
		{
			this.map.obj[address].extension.remove(id);
			this.setChangeType(this.ESSENTIAL_CHANGE);
		}
	}
}

//yarip.resetOnAddress = function(doc, address, xValue, show)
yarip.resetOnAddress = function(obj)
{
//	if (!doc || !address) return false;
	if (!obj) return false;

	var list = null;

	switch (obj.type)
	{
		case this.TYPE_WHITELIST:
			list = this.map.obj[obj.address] ? this.map.obj[obj.address].whitelist : null;
			break;

		case this.TYPE_BLACKLIST:
			list = this.map.obj[obj.address] ? this.map.obj[obj.address].blacklist : null;
			break;

		case this.TYPE_STYLE:
			list = this.map.obj[obj.address] ? this.map.obj[obj.address].styles : null;
			break;
	}

//	if (show)
//	{
		var elements = this.getElementsByXPath(obj.document, obj.xValue);
		if (elements) for (var i = 0; i < elements.snapshotLength; i++)
		{
			var element = elements.snapshotItem(i);
			if (element.nodeType != 1) continue;

			switch (element.getAttribute("status"))
			{
				case "whitelisted":
				case "blacklisted":
				case "styled":
					element.removeAttribute("status");
			}
		}
//	}

	if (list)
	{
		list.remove(obj.xValue);
		this.setChangeType(this.ESSENTIAL_CHANGE);
	}
	/*if (obj.type && obj.xValue)*/ this.undoObj[obj.type + "-" + obj.xValue] = null;

	return true;
}

yarip.whitelist = function(doc, address, xValue, isNew, xpath)
{
	if (!doc || !address || !xValue) return false;

	var elements = this.getElementsByXPath(doc, xValue);
	if (!elements) return false;

	var whitelist = this.map.obj[address] ? this.map.obj[address].whitelist : null;
	var found = false;

	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		switch (element.nodeType)
		{
			// ELEMENT
			case 1:
				if (element.getAttribute("status") == "whitelisted")
				{
					if (whitelist && whitelist.xpaths[xValue])
					{
						whitelist.xpaths[xValue].incrementWhitelisted();
						this.setChangeType(this.MINOR_CHANGE);
					}
					continue;
				}

				if (isNew) element.setAttribute("status", "whitelisted");
				else
				{
					while (element && element.nodeType == 1 && element.getAttribute("status") != "whitelisted")
					{
						element.setAttribute("status", "whitelisted");
		//				element.setAttribute("title", xValue);
						element = element.parentNode;
					}
				}
				break;

			default:
				continue;
		}

		found = true;
	}

	if (isNew && found)
	{
//		if (!this.map.obj[address]) this.map.obj[address] = new YaripPage(null, address);
		if (!this.map.obj[address]) yarip.map.add(new YaripPage(null, address));
		var tmpXPath = xpath ? xpath : new YaripXPath(xValue, this.deep);
		this.map.obj[address].whitelist.add(tmpXPath);
		this.setChangeType(this.MINOR_CHANGE);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xValue;
		obj.type = this.TYPE_WHITELIST;
		this.undoObj[obj.type + "-" + obj.xValue] = obj;
	}

	return found;
}

yarip.blacklist = function(doc, address, xValue, isNew, force, xpath)
{
	if (!doc || !address || !xValue) return false;

	var elements = this.getElementsByXPath(doc, xValue);
	if (!elements) return false;

	var blacklist = this.map.obj[address] ? this.map.obj[address].blacklist : null;
	var found = false;

	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		switch (element.nodeType)
		{
			// ELEMENT
			case 1:
				if (!force && element.getAttribute("status") == "whitelisted")
				{
					if (blacklist && blacklist.xpaths[xValue])
					{
						blacklist.xpaths[xValue].incrementWhitelisted();
						this.setChangeType(this.MINOR_CHANGE);
					}
					continue;
				}

				switch (element.localName.toLowerCase())
				{
					case "html":
					case "body":
						continue;

					case "head":
						element.innerHTML =
							"<style rel='stylesheet' type='text/css'>" +
								"* {" +
									"margin: 0 !important;" +
									"padding: 0 !important;" +
								"}" +
								"table {" +
									"border-spacing: 0 0 !important;" +
									"height: 0 !important;" +
									"width: 0 !important;" +
								"}" +
							"</style>";
						break;

					case "frame":
					case "iframe":
						element.setAttribute("src", "about:blank");
						element.setAttribute("status", "blacklisted");
						break;

					default:
						element.setAttribute("status", "blacklisted");
						if (!isNew) element.innerHTML = "";
				}
				break;

			// ATTRIBUTE
			case 2:
//				element.ownerElement.removeAttribute(element.name); // segmentation fault in Firefox v2.0.0.17!?
				switch (element.localName.toLowerCase())
				{
					case "status":
						continue;

					case "border":
						element.ownerElement.setAttribute(element.name, "0");
						break;

					default:
						element.ownerElement.setAttribute(element.name, "");
				}
				break;

			// TEXT
			case 3:
				element.parentNode.removeChild(element);
				break;

			default:
				continue;
		}

		found = true;
	}

	if (isNew && found)
	{
		if (!this.map.obj[address]) yarip.map.add(new YaripPage(null, address));
		var tmpXPath = xpath ? xpath : new YaripXPath(xValue, this.deep);
		tmpXPath.createStyle();
		this.map.obj[address].blacklist.add(tmpXPath);
		this.setChangeType(this.ESSENTIAL_CHANGE);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xValue;
		obj.type = this.TYPE_BLACKLIST;
		this.undoObj[obj.type + "-" + obj.xValue] = obj;
	}

	return found;
}

yarip.style = function(doc, address, xValue, xStyle, isNew)
{
	if (!doc || !address || !xValue || !xStyle) return false;

	var elements = this.getElementsByXPath(doc, xValue);
	if (!elements) return false;

	var styles = this.map.obj[address] ? this.map.obj[address].styles : null;
	var found = false;

	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		switch (element.nodeType)
		{
			// ELEMENT
			case 1:
				var style = element.getAttribute("style");
				element.setAttribute("style", style ? style + xStyle : xStyle);
				element.setAttribute("status", "styled");
				break;

			default:
				continue;
		}

		found = true;
	}

	if (isNew && found)
	{
		if (!this.map.obj[address]) yarip.map.add(new YaripPage(null, address));
		var xpath = new YaripXPath(xValue, this.deep, null, null, null, xStyle);
		this.map.obj[address].styles.add(xpath);
		this.setChangeType(this.ESSENTIAL_CHANGE);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xValue;
		obj.type = this.TYPE_STYLE;
		this.undoObj[obj.type + "-" + obj.xValue] = obj;
	}

	return found;
}

yarip.calculateXPath = function(element, fullPath)
{
	if (!element) return null;
	if (!element.localName) return null;

	if (element.nodeType == 2) return this.calculateXPath(element.ownerElement, fullPath) + "/@" + element.localName.toLowerCase(); // attribute

	var xValue = "";
	do
	{
		var attributes = "";
		if (element.getAttribute("id"))
		{
			// ID
			attributes += "[@id='" + element.getAttribute("id") + "']";
			if (!fullPath) return "//" + element.localName.toLowerCase() + attributes + xValue; // shortest xpath
		}
		else
		{
			// ATTRIBUTES
			if (element.getAttribute("name")) attributes += "@name='" + element.getAttribute("name") + "' and ";
			if (element.getAttribute("class")) attributes += "@class='" + element.getAttribute("class") + "' and ";
			if (attributes != "") attributes = "[" + attributes.substring(0, attributes.length - 5) + "]";

			// INDEX
			if (!element.localName.match(/^(html|head|title|body|thead|tbody|tfoot|frameset)$/i))
			{
				var index = 1;
				var sibling = element.previousSibling;
				while (sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) ++index;
					sibling = sibling.previousSibling;
				}

				var found = false;
				sibling = element.nextSibling;
				while (!found && sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) found = true;
					else sibling = sibling.nextSibling;
				}
				if (found || index > 1 || this.alwaysUseIndex) attributes = "[" + index + "]" + attributes;
			}
		}
		xValue = "/" + element.localName.toLowerCase() + attributes + xValue;

		element = element.parentNode;
	} while (element && element.nodeType == 1);

	return xValue != "" ? xValue : null;
}

yarip.getElementsByXPath = function(doc, xValue)
{
	var elements = null;
	try { elements = doc.evaluate(xValue, doc, null, Components.interfaces.nsIDOMXPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null); }
	catch(e)
	{
		var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
		var scriptError = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
//		var message = doc.getElementById("yarip-overlay-stringbundle").getFormattedString("malformedXpath", [xValue]);
//		var sourceName = "chrome://yarip/content/yarip.js";
		var sourceName = "";
		scriptError.init(e.message, sourceName, null, e.lineNumber, e.columnNumber, scriptError.errorFlag, "content javascript");
		consoleService.logMessage(scriptError);
	}
//	if (!elements || elements.snapshotLength == 0) return null;
	return elements;
}

yarip.save = function()
{
	if (this.changeType == this.NO_CHANGE) return;

	// SAVE XPATHS
	var file = this.getFile(this.XPATH);
	this.map.sortPages(true);
	var data = this.map.generateXml();
	this.saveToFile(data, file);

	if (this.changeType == this.ESSENTIAL_CHANGE)
	{
		// SAVE STYLES
		file = this.getFile(this.STYLE);
		data = this.map.generateCSS();
		this.saveToFile(data, file);

		if (file)
		{
			var uri = "file://" + file.path;
			this.injectCSS(uri, false);
			this.injectCSS(uri, true);
		}
	}

	this.setChangeType(this.NO_CHANGE, true);
	this.setValue(this.RELOAD, (new Date()).getTime(), this.STRING); // notify
}

yarip.getValue = function(preference, defaultValue, type)
{
	try
	{
		switch(type)
		{
			case this.BOOLEAN:
				return prefBranch.getBoolPref(preference);

			case this.INTEGER:
				return prefBranch.getIntPref(preference);

			case this.STRING:
				return prefBranch.getCharPref(preference);
		}
	}
	catch(e)
	{
		if (defaultValue != false && typeof defaultValue != "number" && !defaultValue) return null;

		this.setValue(preference, defaultValue, type);
	}

	return this.getValue(preference, null, type);
}

yarip.setValue = function(preference, value, type)
{
	try
	{
		switch(type)
		{
			case this.BOOLEAN:
				prefBranch.setBoolPref(preference, "" + value == "true");
				break;

			case this.INTEGER:
				prefBranch.setIntPref(preference, value);
				break;

			case this.STRING:
				prefBranch.setCharPref(preference, value);
				break;

			case this.RESET:
				prefBranch.clearUserPref(preference);
		}
	}
	catch(e){}
}

yarip.injectCSS = function(uri, value)
{
	if (!uri) return;

	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uri = ios.newURI(uri, this.CHARSET, null); // uri, charset, baseuri
	var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService);
	if (value) { if (!sss.sheetRegistered(uri, sss.USER_SHEET)) sss.loadAndRegisterSheet(uri, sss.USER_SHEET); }
	else { if (sss.sheetRegistered(uri, sss.USER_SHEET)) sss.unregisterSheet(uri, sss.USER_SHEET); }
}

yarip.check = function()
{
	// FIRST RUN
	var firstrun = this.getValue(this.FIRSTRUN, true, this.BOOLEAN);
	if (firstrun)
	{
		this.setValue(this.FIRSTRUN, false, this.BOOLEAN);
	}

	// UPGRADE
	var version = this.getValue(this.VERSION, "", this.STRING);
	var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var current = extensionManager.getItemForID("yarip@mozdev.org").version;
	if (version != current && !firstrun)
	{
		this.setValue(this.VERSION, current, this.STRING);
		if (!current.match(/^0\.1\.[4-7]$/))
		{
			// CREATE STYLES FOR XPATHS
			for (var p in this.map.obj)
			{
				if (this.map.obj[p])
				{
					for (var x in this.map.obj[p].blacklist.xpaths)
					{
						if (this.map.obj[p].blacklist.xpaths[x]) this.map.obj[p].blacklist.xpaths[x].createStyle(true);
					}
				}
			}

			this.setChangeType(this.ESSENTIAL_CHANGE);
		}

		// REMOVE PREFERENCES
		if (!current.match(/^0\.1\.7$/))
		{
			this.setValue("extensions.yarip.changeType.value", null, this.RESET);
			this.setValue("extensions.yarip.flickerType.value", null, this.RESET);
		}
	}
}

yarip.getId = function()
{
	var id = (new Date()).getTime();
	while (this.map.objId["" + id] != undefined && this.map.objId["" + id] != null) id++;
	return "" + id;
}

yarip.load = function(path)
{
	var file = this.getFile(path);
	var doc = this.getDoc(file);
	if (!doc)
	{
		this.setChangeType(this.ESSENTIAL_CHANGE);
		this.save();
		return false;
	}
	else if (doc.documentElement.nodeName == "parsererror") return false;

	var iPage = doc.evaluate("./yarip/page", doc, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
	var nPage = iPage.iterateNext();
	while (nPage)
	{
		var page = new YaripPage(
			nPage.getAttribute("id"),
			nPage.getAttribute("name"));
		var id = page.getId();
		var name = page.getName();
		this.map.add(page);

		// WHITELIST
		var iWhitelist = doc.evaluate("./whitelist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
		var nWhitelist = iWhitelist.iterateNext();
		if (nWhitelist)
		{
			var iXPath = doc.evaluate("./xpath", nWhitelist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
			var nXPath = iXPath.iterateNext();
			while (nXPath)
			{
				page.whitelist.add(new YaripXPath(
					nXPath.getAttribute("value"),
					nXPath.getAttribute("deep"),
					nXPath.getAttribute("found"),
					nXPath.getAttribute("notFound"),
					nXPath.getAttribute("whitelisted")));
				nXPath = iXPath.iterateNext();
			}
		}

		// BLACKLIST
		var iBlacklist = doc.evaluate("./blacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
		var nBlacklist = iBlacklist.iterateNext();
		if (nBlacklist)
		{
			var iXPath = doc.evaluate("./xpath", nBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
			var nXPath = iXPath.iterateNext();
			while (nXPath)
			{
				page.blacklist.add(new YaripXPath(
					nXPath.getAttribute("value"),
					nXPath.getAttribute("deep"),
					nXPath.getAttribute("found"),
					nXPath.getAttribute("notFound"),
					nXPath.getAttribute("whitelisted"),
					nXPath.getAttribute("style"),
					nXPath.getAttribute("dependsOnWhitelist"),
					nXPath.getAttribute("force")));
				nXPath = iXPath.iterateNext();
			}
		}

		// STYLES
		var iStyles = doc.evaluate("./styles", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
		var nStyles = iStyles.iterateNext();
		if (nStyles)
		{
			var iXPath = doc.evaluate("./xpath", nStyles, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
			var nXPath = iXPath.iterateNext();
			while (nXPath)
			{
				page.styles.add(new YaripXPath(
					nXPath.getAttribute("value"),
					nXPath.getAttribute("deep"),
					nXPath.getAttribute("found"),
					nXPath.getAttribute("notFound"),
					null,
					nXPath.getAttribute("style")));
				nXPath = iXPath.iterateNext();
			}
		}

		// EXTENSION
		var iExtension = doc.evaluate("./extension", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
		var nExtension = iExtension.iterateNext();
		if (nExtension)
		{
			var iXPath = doc.evaluate("./item", nExtension, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
			var nXPath = iXPath.iterateNext();
			while (nXPath)
			{
				page.extension.add(new YaripItem(nXPath.getAttribute("value")));
				nXPath = iXPath.iterateNext();
			}
		}

		nPage = iPage.iterateNext();
	}

	return true;
}

yarip.getDoc = function(file)
{
	if (!file) return null;

	var data = this.getData(file);
	if (!data || data == "") return null;

	var parser = Components.classes['@mozilla.org/xmlextras/domparser;1'].createInstance(Components.interfaces.nsIDOMParser);
	return parser.parseFromString(data, "text/xml");
}

yarip.getData = function(file)
{
	if (!file) return "";

	var fis = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
	fis.init(file, 0x01, 00004, null);
	var sis = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
	sis.init(fis);
	var data = sis.read(sis.available());
	var suc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	suc.charset = this.CHARSET;
	var data = suc.ConvertToUnicode(data);
	sis.close();
	fis.close();
	return data;
}

yarip.getFile = function(path)
{
	if (!path) return null;

	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	var aPath = path.split(/\/|\\/);
	for (var i = 0; i < aPath.length; i++) file.append(aPath[i]);
	if (!file.exists()) file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
	if (file.isFile()) return file;
	else return null;
}

yarip.saveToFile = function(data, file)
{
	if (!data || !file) return;

	var fos = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	fos.init(file, 0x02 | 0x08 | 0x20, 0600, 0);
	fos.write(data, data.length);
	fos.close();
}

yarip.QueryInterface = function(aIID)
{
	if (/*!aIID.equals(nsIYarip) &&*/ !aIID.equals(nsISupports)) throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
}

yarip.wrappedJSObject = yarip;

var factory = {
	createInstance: function (aOuter, aIID)
	{
		if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;

		var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
		loader.loadSubScript("chrome://yarip/content/map.js");
		loader.loadSubScript("chrome://yarip/content/page.js");
		loader.loadSubScript("chrome://yarip/content/list.js");
		loader.loadSubScript("chrome://yarip/content/xpath.js");

		yarip.map = new YaripMap();

//		yarip = (new Yarip()).QueryInterface(aIID);
//		yarip = yarip.QueryInterface(aIID);

		yarip.load(yarip.XPATH);
		yarip.check();
		yarip.toggleEnabled(yarip.getValue(yarip.ENABLED, true, yarip.BOOLEAN));
		yarip.setMode(yarip.FQDN_MODE);
		yarip.setAlwaysUseIndex(yarip.getValue(yarip.INDEX, false, yarip.BOOLEAN));

		return yarip;
	}
}

var module = {
	registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
	{
		aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
	},

	unregisterSelf: function(aCompMgr, aLocation, aType)
	{
		aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
	},

	getClassObject: function(aCompMgr, aCID, aIID)
	{
		if (!aIID.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		if (aCID.equals(CLASS_ID)) return factory;
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},

	canUnload: function(aCompMgr) { return true; }
}

function NSGetModule(aCompMgr, aFileSpec) { return module; }
